
public class DeathLockExample {
	
	private Object lock1 = new Object();
	private Object lock2 = new Object();
	
	private void method1() {
		try {
			synchronized (lock1) {
				String name = Thread.currentThread().getName();
				System.out.println("Methode 1 wird von Thread "+name+" aufgerufen");
				Thread.sleep(1000);
				System.out.println(name+" will jetzt method 2 aufrufen");
				method2(); // wird nicht klappen, weil der andere Thread lock02 sperrt
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	private void method2() {
		try {
			synchronized (lock2) {
				String name = Thread.currentThread().getName();
				System.out.println("Methode 2 wird von Thread "+name+" aufgerufen");
				Thread.sleep(1000);
				System.out.println(name+" will jetzt method 1 aufrufen");
				method1(); // wird nicht klappen, weil der andere Thread lock01 sperrt
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		final DeathLockExample example = new DeathLockExample();
		
		// Fhre example.method1 in einem neuen Thread aus
		new Thread() {
			public void run() {
				example.method1();
				System.out.println("Thread 1 ist fertig");
			}
		}.start();
		
		// Fhre example.method2 in einem neuen Thread aus
		new Thread() {
			public void run() {
				example.method2();
				System.out.println("Thread 2 ist fertig");
			}
		}.start();

		/*
		 * Der Main-Thread endet hier, aber die beiden neuen Threads stecken in
		 * method01 und method02 fest.
		 */
	}

}
